; Example Program pcc01.a51
; PC Communication via RS232
; Chin-Shiuh Shieh
; 2003-05-08
;
;Memory Allocation
ADC_BUSY	EQU		00h		; Bit for ADC Status
;Pin Assignment
LED_PORT	EQU		P0
ADC_PORT	EQU		P1
ADC_CS		EQU		P2.0
ADC_RD		EQU		P2.1
ADC_WR		EQU		P2.2
;
PROG	EQU		4000h
		ORG		PROG+0000h
		SJMP	START
;Interrupt Vector Table
		ORG		PROG+0003h
		LCALL	INT0_ISR
		RETI
		ORG		PROG+000Bh
		LCALL	T0_ISR
		RETI
		ORG		PROG+0013h
		LCALL	INT1_ISR
		RETI
		ORG		PROG+001Bh
		LCALL	T1_ISR
		RETI
		ORG		PROG+0023h
		LCALL	UART_ISR
		RETI
;
		ORG		PROG+0030h
START:
		CLR		ADC_BUSY
        MOV     TMOD,#00100001b	; Timer1 in Mode 2, Timer0 in Mode 1
        MOV     TH1, #0FDh		; Baud Rate = 9600 bps at 11.0592MHz
        MOV     SCON,#01010000b	; UART in Mode 1
		SETB	IT0				; Set External Interrupt 0 to be falling edge triggered
		SETB	PX0				; Set Priority of External0 to Level 1
		SETB	EX0				; Enable External Interrut 0
		SETB	ES				; Enable UART Interrupt
		SETB	EA				; Enable Interrupt
		SETB	TR1				; Start Timer 1
DONE:	SJMP	DONE
;
INT0_ISR:
		CLR		ADC_BUSY
		RET
T0_ISR:
		RET
INT1_ISR:
		RET
T1_ISR:
		RET
;
UART_ISR:
        JB      RI,RECEIVED
TRANSMITTED:
        CLR     TI
        RET
RECEIVED:
		MOV		A,SBUF
		CPL		A
		MOV		LED_PORT,A
		CALL	ADC
		MOV		SBUF,A
		CLR     RI
        RET
;
ADC:
		SETB	ADC_BUSY
		CLR		ADC_CS
		CLR		ADC_WR
		SETB	ADC_WR
		SETB	ADC_CS
ADC_WAIT:
		JB		ADC_BUSY,ADC_WAIT
		CLR		ADC_CS
		CLR		ADC_RD
		MOV     A,ADC_PORT
		SETB	ADC_RD
		SETB	ADC_CS
		RET
;
	END